Package com.collabnet.ce.soap60.webservices.frs

# Class FrsAppSoap

java.lang.Object
com.collabnet.ce.soap60.webservices.WebService
com.collabnet.ce.soap60.webservices.frs.FrsAppSoap

All Implemented Interfaces:
  `IFrsAppSoap`

public class FrsAppSoap extends WebService implements IFrsAppSoap
Provides SOAP services for managing the file release system.

Change History

Version 23.1

- createFrsFile2: to support the downloaded field.
- getFrsFileData2: to support the downloaded field.
- getFrsFileList2: to support the downloaded field.

Version 20.1

- createRelease: Updated to support 'obsolete' release status.
- setReleaseData: Updated to support 'obsolete' release status.

Version 8.0

- getArtifactListReportedInRelease2: New operation added to get the autoSummingPoints and Team field information.
- getArtifactListResolvedInRelease2: New operation added to get the autoSummingPoints and Team field information.

Version 6.1

- getArtifactListReportedInRelease2: Removed and merged into getArtifactListReportedInRelease.
- getArtifactListResolvedInRelease2: Removed and merged into getArtifactListResolvedInRelease.

Version 5.4

- Added getArtifactListReportedInRelease2 to support the story points field
- Added getArtifactListResolvedInRelease2 to support the story points field

Version 5.3

- getArtifactListReportedInRelease: New operation added in 5.3
- getArtifactListResolvedInRelease: New operation added in 5.3

Version 4.4

- PackageSoapDO: Added new methods getIsPublished and setIsPublished

- createPackage: Added new parameter to call in 4.4
- createPackage2: Removed in 4.4. Use createPackage instead
- isPackagePublished: Removed in 4.4. Use getPackageData and call PackageSoapDO.getIsPublished() instead
- setPackagePublished: Removed in 4.4. Use PackageSoapDO.setIsPublished() and setPackageData instead
- getReleaseDownloadCount: Removed in 4.4. Use getReleaseData and call ReleaseSoapDO.getDownloaded() instead
- getPackageDownloadCount: Removed in 4.4. Use getPackageData and call PackageSoapDO.getDownloaded() instead

Since:
  4.1

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FrsAppSoap()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `FrsFileSoapDO`
  `createFrsFile(String sessionId, String releaseId, String fileName, String mimeType, String fileId)`
  Creates a new FRS file and adds it to the specified release.
  `FrsFile2SoapDO`
  `createFrsFile2(String sessionId, String releaseId, String fileName, String mimeType, String fileId)`
  Creates a new FRS file and adds it to the specified release.
  `PackageSoapDO`
  `createPackage(String sessionId, String projectId, String title, String description, boolean isPublished)`
  Creates a new FRS package.
  `ReleaseSoapDO`
  `createRelease(String sessionId, String packageId, String title, String description, String status, String maturity)`
  Creates a new release within a specified package.
  `void`
  `deleteFrsFile(String sessionId, String frsFileId)`
  Deletes the specified file.
  `void`
  `deletePackage(String sessionId, String packageId)`
  Deletes the specified package.
  `void`
  `deleteRelease(String sessionId, String releaseId)`
  Deletes the specified release.
  `ArtifactSoapList`
  `getArtifactListReportedInRelease(String sessionId, String releaseId)`
  Lists artifacts that were found in the given release.
  `Artifact2SoapList`
  `getArtifactListReportedInRelease2(String sessionId, String releaseId)`
  Lists artifacts that were found in the given release.
  `ArtifactSoapList`
  `getArtifactListResolvedInRelease(String sessionId, String releaseId)`
  Lists artifacts that were resolved in the given release.
  `Artifact2SoapList`
  `getArtifactListResolvedInRelease2(String sessionId, String releaseId)`
  Lists artifacts that were resolved in the given release.
  `FrsFileSoapDO`
  `getFrsFileData(String sessionId, String frsFileId)`
  Gets FRS file data.
  `FrsFile2SoapDO`
  `getFrsFileData2(String sessionId, String frsFileId)`
  Gets FRS file data.
  `String`
  `getFrsFileId(String sessionId, String frsFileId)`
  Returns a temporary file storage object id to download an FRS file.
  `FrsFileSoapList`
  `getFrsFileList(String sessionId, String releaseId)`
  Returns a list of files within a release.
  `FrsFile2SoapList`
  `getFrsFileList2(String sessionId, String releaseId)`
  Returns a list of files within a release.
  `PackageSoapDO`
  `getPackageData(String sessionId, String packageId)`
  Returns package data.
  `PackageSoapList`
  `getPackageList(String sessionId, String projectId)`
  Lists packages within a project.
  `ReleaseSoapDO`
  `getReleaseData(String sessionId, String releaseId)`
  Returns the specified release data.
  `ReleaseSoapList`
  `getReleaseList(String sessionId, String packageId)`
  Lists the releases within a specified package.
  `void`
  `setPackageData(String sessionId, PackageSoapDO packageData)`
  Returns package data.
  `void`
  `setReleaseData(String sessionId, ReleaseSoapDO releaseData)`
  Sets the specified release data.

  ### Methods inherited from class com.collabnet.ce.soap60.webservices.WebService

  `assertNormalProject, assertProjectGroup, canGiveFullUserDetails, checkGeneralPermission, checkPermission, checkPermission, checkSiteWidePermission, createUserSessionKey, downloadFile, filterInvalidProjMembers, generateFolderName, getAccessControlService, getApplicationRegistryService, getAttachment, getAuthenticationService, getCategorization, getCoreService, getDiscussion, getDocMan, getDocumentRootFolder, getFileStorageService, getFolderKey, getFolderPath, getFolderPath, getFolderPath, getFrs, getIntegrationData, getItemPath, getItemPath, getLocale, getMonitoring, getNews, getNulledMinSoapDate, getObjectKey, getObjectPath, getOperation, getPages, getPlanning, getPluggableComponent, getProjectId, getProjectPath, getProjectPath, getRbac, getSearch, getStoredFileSize, getStoredFileText, getTagService, getTeam, getTemplate, getTracker, getUser, getUserData, getUsername, getUserService, getWiki, hasPermission, hasSiteWidePermission, isFolderResource, isProjectGroup, isProjectId, isStrEmpty, isSuperUser, isValidEmail, makeStoredFileDO, makeStoredFileDOs, requireProjectAdminPermission, setPartialOrFullUserData, setUserNameToResponse, storeFile, storeTextFile, validateChoice, validateChoice, validateIconFile, validateString, validateStringArray, validateStringWithTrim, validateTokenAndExactUsername, validateTokenAndExactUsername, validateWikiPageName, verifyLicense`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### FrsAppSoap

    public FrsAppSoap()

- ## Method Details

  - ### createPackage

    public PackageSoapDO createPackage(String sessionId, String projectId, String title, String description, boolean isPublished) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault
    Creates a new FRS package.

    Requires OperationConstants.FRSAPPFOLDER_CREATE_CREATEPACKAGE

    Change History
    Version 4.4
    - Added additional parameter `isPublished`
    Specified by:
      `createPackage` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project id.
      `title` - Package title.
      `description` - Package description.
      `isPublished` - Whether the package should be published
    Returns:
      Newly created package object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `IllegalArgumentFault` - when one or more parameters are invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getPackageList

    public PackageSoapList getPackageList(String sessionId, String projectId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists packages within a project.
    Specified by:
      `getPackageList` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project id.
    Returns:
      List of packages within the specified project.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getPackageData

    public PackageSoapDO getPackageData(String sessionId, String packageId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Returns package data.
    Specified by:
      `getPackageData` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `packageId` - The package id.
    Returns:
      Package object data.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### setPackageData

    public void setPackageData(String sessionId, PackageSoapDO packageData) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, VersionMismatchFault, IllegalArgumentFault, SystemFault
    Returns package data.

    Requires OperationConstants.PACKAGE_EDIT_EDIT

    Specified by:
      `setPackageData` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `packageData` - The package object to edit.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `VersionMismatchFault` - when package data is stale.
      `IllegalArgumentFault` - when one or more parameters are invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### deletePackage

    public void deletePackage(String sessionId, String packageId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Deletes the specified package.
    Specified by:
      `deletePackage` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `packageId` - The package id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getReleaseList

    public ReleaseSoapList getReleaseList(String sessionId, String packageId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists the releases within a specified package.
    Specified by:
      `getReleaseList` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `packageId` - The package id.
    Returns:
      List of releases within the specified package.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### createRelease

    public ReleaseSoapDO createRelease(String sessionId, String packageId, String title, String description, String status, String maturity) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault
    Creates a new release within a specified package. 'obsolete' status value is supported since TeamForge 20.1
    Specified by:
      `createRelease` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `packageId` - The package id.
      `title` - Release title.
      `description` - Release description.
      `status` - Release status ("active", "pending", "obsolete")
      `maturity` - Maturity level ("Alpha", etc.)
    Returns:
      Newly created release object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `IllegalArgumentFault` - when one or more parameters are invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### deleteRelease

    public void deleteRelease(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Deletes the specified release.
    Specified by:
      `deleteRelease` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getReleaseData

    public ReleaseSoapDO getReleaseData(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Returns the specified release data.
    Specified by:
      `getReleaseData` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
    Returns:
      Release data.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### setReleaseData

    public void setReleaseData(String sessionId, ReleaseSoapDO releaseData) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, VersionMismatchFault, IllegalArgumentFault, SystemFault
    Sets the specified release data. 'obsolete' status value is supported since TeamForge 20.1
    Specified by:
      `setReleaseData` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseData` - The release object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `VersionMismatchFault` - when package data is stale.
      `IllegalArgumentFault` - when release data is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### createFrsFile

    public FrsFileSoapDO createFrsFile(String sessionId, String releaseId, String fileName, String mimeType, String fileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault
    Creates a new FRS file and adds it to the specified release.
    Specified by:
      `createFrsFile` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
      `fileName` - Name of the attached file.
      `mimeType` - File mime type.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
    Returns:
      Newly created frs file object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `IllegalArgumentFault` - when one or more parameters are invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getFrsFileData

    public FrsFileSoapDO getFrsFileData(String sessionId, String frsFileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault, IllegalArgumentFault
    Gets FRS file data.
    Specified by:
      `getFrsFileData` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `frsFileId` - FRS file id of the object to retrieve.
    Returns:
      the FRS file data.
    Throws:
      `InvalidSessionFault` - when SOAP session id is invalid.
      `NoSuchObjectFault` - when frsFileId does not exist.
      `PermissionDeniedFault` - when permissions are insufficient.
      `SystemFault` - when an unexpected error occurs.
      `IllegalArgumentFault` - when an argument is invalid.
    Since:
      4.2

  - ### getFrsFileList

    public FrsFileSoapList getFrsFileList(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Returns a list of files within a release.
    Specified by:
      `getFrsFileList` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
    Returns:
      List of files within the specified release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### deleteFrsFile

    public void deleteFrsFile(String sessionId, String frsFileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Deletes the specified file.
    Specified by:
      `deleteFrsFile` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `frsFileId` - The frs file id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### getFrsFileId

    public String getFrsFileId(String sessionId, String frsFileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Returns a temporary file storage object id to download an FRS file. The returned file storage id should be used with one of the file storage services to download the file (e.g. FileStorageApp or SimpleFileStorageApp service).
    IMPORTANT: The returned file id is valid ONLY during the session.
    Specified by:
      `getFrsFileId` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `frsFileId` - FRS File id.
    Returns:
      File storage id (for download using FileStorageService or SimpleFileStorageService).
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      4.1

  - ### createFrsFile2

    public FrsFile2SoapDO createFrsFile2(String sessionId, String releaseId, String fileName, String mimeType, String fileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault
    Creates a new FRS file and adds it to the specified release.
    Specified by:
      `createFrsFile2` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
      `fileName` - Name of the attached file.
      `mimeType` - File mime type.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
    Returns:
      Newly created frs file object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `IllegalArgumentFault` - when one or more parameters are invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      23.1

  - ### getFrsFileData2

    public FrsFile2SoapDO getFrsFileData2(String sessionId, String frsFileId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault, IllegalArgumentFault
    Gets FRS file data.
    Specified by:
      `getFrsFileData2` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `frsFileId` - FRS file id of the object to retrieve.
    Returns:
      the FRS file data.
    Throws:
      `InvalidSessionFault` - when SOAP session id is invalid.
      `NoSuchObjectFault` - when frsFileId does not exist.
      `PermissionDeniedFault` - when permissions are insufficient.
      `SystemFault` - when an unexpected error occurs.
      `IllegalArgumentFault` - when an argument is invalid.
    Since:
      23.1

  - ### getFrsFileList2

    public FrsFile2SoapList getFrsFileList2(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Returns a list of files within a release.
    Specified by:
      `getFrsFileList2` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The release id.
    Returns:
      List of files within the specified release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      23.1

  - ### getArtifactListReportedInRelease

    public ArtifactSoapList getArtifactListReportedInRelease(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists artifacts that were found in the given release.
    Specified by:
      `getArtifactListReportedInRelease` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The id of the release
    Returns:
      List of the artifacts reported in the given release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      5.3

  - ### getArtifactListReportedInRelease2

    public Artifact2SoapList getArtifactListReportedInRelease2(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists artifacts that were found in the given release. The difference between this method and getArtifactListReportedInRelease is that this returns `Artifact2SoapList` that adds the autoSummingpoints and Team field information on the artifact
    Specified by:
      `getArtifactListReportedInRelease2` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The id of the release
    Returns:
      List of the artifacts reported in the given release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      8.0

  - ### getArtifactListResolvedInRelease

    public ArtifactSoapList getArtifactListResolvedInRelease(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists artifacts that were resolved in the given release.
    Specified by:
      `getArtifactListResolvedInRelease` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The id of the release
    Returns:
      List of the artifacts resolved in the given release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      5.3

  - ### getArtifactListResolvedInRelease2

    public Artifact2SoapList getArtifactListResolvedInRelease2(String sessionId, String releaseId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists artifacts that were resolved in the given release. The difference between this method and getArtifactListResolvedInRelease is that this returns `Artifact2SoapList` that adds the autoSummingPoints and Team field information on the artifact.
    Specified by:
      `getArtifactListResolvedInRelease2` in interface `IFrsAppSoap`
    Parameters:
      `sessionId` - User session id.
      `releaseId` - The id of the release
    Returns:
      List of the artifacts resolved in the given release.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
    Since:
      8.0